//
//  SWGamaClient.h
//  PlaySDK
//
//  Created by BlingBling on 2020/9/7.
//  Copyright © 2020 iShunwan. All rights reserved.
//

#import <Foundation/Foundation.h>

NS_ASSUME_NONNULL_BEGIN

@class SWGamePlayer;
@class SWPlayerView;
@class SWGameClient;

@protocol SWGameClientDelegate <NSObject>
@optional
- (void)gameClient:(SWGameClient *)gameClient onErrorNotifyErrorCode:(NSInteger)code errorMsg:(NSString *)errorMsg;
- (void)gameClient:(SWGameClient *)gameClient onUserListUpdate:(NSArray *)userList;
- (void)gameClient:(SWGameClient *)gameClient onCtrlPadUpdate:(NSArray *)ctrlPadList;
- (void)gameClient:(SWGameClient *)gameClient onUserJoin:(NSString *)userId;
- (void)gameClient:(SWGameClient *)gameClient onUserOffline:(NSString *)userId;
- (void)gameClient:(SWGameClient *)gameClient onUserOnline:(NSString *)userId;
- (void)gameClient:(SWGameClient *)gameClient onUserLeave:(NSString *)userId;
- (void)gameClient:(SWGameClient *)gameClient onKick:(NSString *)userId;
- (void)gameClient:(SWGameClient *)gameClient onBan:(NSString *)userId;
- (void)gameClient:(SWGameClient *)gameClient onPlayUpdatePositionList:(NSArray *)positionList;

@end

@interface SWGameClient : NSObject

+ (SWGameClient *)initGameClientWithAppID:(NSString *)app_id delegate:(id<SWGameClientDelegate>)delegate;

- (void)debugMode:(BOOL)debugMode;

- (void)joinChannelBychannelId:(NSString * _Nonnull)channelId
                           uid:(NSString * _Nonnull)uid
                           token:(NSString *)token
                   joinSuccess:(void(^ _Nullable)(NSString * _Nonnull channel, NSUInteger uid))joinSuccessBlock
                    joinFailed:(void(^ _Nullable)(NSError * _Nonnull error))joinFailedBlock;

- (void)setPlayCloudGame:(NSInteger)gameId padCount:(NSInteger)padCount
                setSuccess:(void(^ _Nullable)(void))setSuccessBlock
                setFailed:(void(^ _Nullable)(NSError * _Nonnull error))setFailedBlock;

- (SWGamePlayer *)createWithPlayView:(SWPlayerView *)playView createFailed:(void(^ _Nullable)(NSError * _Nonnull error))createFailed;

- (void)leaveChannel;

- (void)destroy;

@end

NS_ASSUME_NONNULL_END
